Index: serefpolicy-contrib-20140730/nis.if
===================================================================
--- serefpolicy-contrib-20140730.orig/nis.if
+++ serefpolicy-contrib-20140730/nis.if
@@ -1,4 +1,4 @@
-## <summary>Policy for NIS (YP) servers and clients.</summary>
+## <summary>Policy for NIS (YP) servers and clients</summary>
 
 ########################################
 ## <summary>
@@ -27,18 +27,15 @@ interface(`nis_use_ypbind_uncond',`
 	gen_require(`
 		type var_yp_t;
 	')
-
-	allow $1 self:capability net_bind_service;
+	dontaudit $1 self:capability net_bind_service;
 
 	allow $1 self:tcp_socket create_stream_socket_perms;
 	allow $1 self:udp_socket create_socket_perms;
 
 	allow $1 var_yp_t:dir list_dir_perms;
-	allow $1 var_yp_t:file read_file_perms;
 	allow $1 var_yp_t:lnk_file read_lnk_file_perms;
+	allow $1 var_yp_t:file read_file_perms;
 
-	corenet_all_recvfrom_unlabeled($1)
-	corenet_all_recvfrom_netlabel($1)
 	corenet_tcp_sendrecv_generic_if($1)
 	corenet_udp_sendrecv_generic_if($1)
 	corenet_tcp_sendrecv_generic_node($1)
@@ -49,14 +46,11 @@ interface(`nis_use_ypbind_uncond',`
 	corenet_udp_bind_generic_node($1)
 	corenet_tcp_bind_generic_port($1)
 	corenet_udp_bind_generic_port($1)
-	corenet_dontaudit_tcp_bind_all_reserved_ports($1)
-	corenet_dontaudit_udp_bind_all_reserved_ports($1)
 	corenet_dontaudit_tcp_bind_all_ports($1)
 	corenet_dontaudit_udp_bind_all_ports($1)
 	corenet_tcp_connect_portmap_port($1)
-	corenet_tcp_connect_reserved_port($1)
+	corenet_tcp_connect_all_reserved_ports($1)
 	corenet_tcp_connect_generic_port($1)
-	corenet_dontaudit_tcp_connect_all_ports($1)
 	corenet_sendrecv_portmap_client_packets($1)
 	corenet_sendrecv_generic_client_packets($1)
 	corenet_sendrecv_generic_server_packets($1)
@@ -88,14 +82,14 @@ interface(`nis_use_ypbind_uncond',`
 ## <rolecap/>
 #
 interface(`nis_use_ypbind',`
-	tunable_policy(`allow_ypbind',`
+	tunable_policy(`nis_enabled',`
 		nis_use_ypbind_uncond($1)
 	')
 ')
 
 ########################################
 ## <summary>
-##	Use nis to authenticate passwords.
+##	Use the nis to authenticate passwords
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -105,7 +99,7 @@ interface(`nis_use_ypbind',`
 ## <rolecap/>
 #
 interface(`nis_authenticate',`
-	tunable_policy(`allow_ypbind',`
+	tunable_policy(`nis_enabled',`
 		nis_use_ypbind_uncond($1)
 		corenet_tcp_bind_all_rpc_ports($1)
 		corenet_udp_bind_all_rpc_ports($1)
@@ -133,20 +127,19 @@ interface(`nis_domtrans_ypbind',`
 
 #######################################
 ## <summary>
-##	Execute ypbind in the caller domain.
+##  Execute ypbind in the caller domain.
 ## </summary>
 ## <param name="domain">
-##	<summary>
-##	Domain allowed access.
-##	</summary>
+##  <summary>
+##  Domain allowed to transition.
+##  </summary>
 ## </param>
 #
 interface(`nis_exec_ypbind',`
-	gen_require(`
-		type ypbind_exec_t;
-	')
+    gen_require(`
+        type ypbind_t, ypbind_exec_t;
+    ')
 
-	corecmd_search_bin($1)
 	can_exec($1, ypbind_exec_t)
 ')
 
@@ -169,11 +162,11 @@ interface(`nis_exec_ypbind',`
 #
 interface(`nis_run_ypbind',`
 	gen_require(`
-		attribute_role ypbind_roles;
+		type ypbind_t;
 	')
 
 	nis_domtrans_ypbind($1)
-	roleattribute $2 ypbind_roles;
+	role $2 types ypbind_t;
 ')
 
 ########################################
@@ -196,7 +189,7 @@ interface(`nis_signal_ypbind',`
 
 ########################################
 ## <summary>
-##	List nis data directories.
+##	List the contents of the NIS data directory.
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -272,10 +265,11 @@ interface(`nis_read_ypbind_pid',`
 #
 interface(`nis_delete_ypbind_pid',`
 	gen_require(`
-		type ypbind_var_run_t;
+		type ypbind_t;
 	')
 
-	allow $1 ypbind_var_run_t:file delete_file_perms;
+	# TODO: add delete pid from dir call to files
+	allow $1 ypbind_t:file unlink;
 ')
 
 ########################################
@@ -355,8 +349,57 @@ interface(`nis_initrc_domtrans_ypbind',`
 
 ########################################
 ## <summary>
-##	All of the rules required to
-##	administrate an nis environment.
+##	Execute ypbind server in the ypbind domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`nis_systemctl_ypbind',`
+	gen_require(`
+		type ypbind_unit_file_t;
+		type ypbind_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 ypbind_unit_file_t:file read_file_perms;
+	allow $1 ypbind_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, ypbind_t)
+')
+
+########################################
+## <summary>
+##	Execute ypbind server in the ypbind domain.
+## </summary>
+## <param name="domain">
+##	<summary>
+##	Domain allowed to transition.
+##	</summary>
+## </param>
+#
+interface(`nis_systemctl',`
+	gen_require(`
+		type nis_unit_file_t, ypbind_unit_file_t;
+		type ypbind_t, yppasswdd_t, ypserv_t, ypxfr_t;
+	')
+
+	systemd_exec_systemctl($1)
+	allow $1 nis_unit_file_t:file read_file_perms;
+	allow $1 nis_unit_file_t:service manage_service_perms;
+
+	ps_process_pattern($1, ypbind_t)
+	ps_process_pattern($1, yppasswdd_t)
+	ps_process_pattern($1, ypserv_t)
+	ps_process_pattern($1, ypxfr_t)
+')
+
+########################################
+## <summary>
+##	All of the rules required to administrate
+##	an nis environment
 ## </summary>
 ## <param name="domain">
 ##	<summary>
@@ -372,32 +415,56 @@ interface(`nis_initrc_domtrans_ypbind',`
 #
 interface(`nis_admin',`
 	gen_require(`
-		type ypbind_t, yppasswdd_t, ypserv_t, ypxfr_t;
-		type ypbind_tmp_t, ypserv_tmp_t, ypserv_conf_t;
+		type ypbind_t, yppasswdd_t, ypserv_t;
+		type ypserv_conf_t;
 		type ypbind_var_run_t, yppasswdd_var_run_t, ypserv_var_run_t;
-		type ypbind_initrc_exec_t, nis_initrc_exec_t, var_yp_t;
+		type ypserv_tmp_t;
+		type ypbind_initrc_exec_t, nis_initrc_exec_t, ypxfr_t;
+		type nis_unit_file_t;
+		type ypbind_unit_file_t;
+	')
+
+	allow $1 ypbind_t:process signal_perms;
+	ps_process_pattern($1, ypbind_t)
+	tunable_policy(`deny_ptrace',`',`
+		allow $1 ypbind_t:process ptrace;
+		allow $1 yppasswdd_t:process ptrace;
+		allow $1 ypserv_t:process ptrace;
+		allow $1 ypxfr_t:process ptrace;
 	')
 
-	allow $1 { ypbind_t yppasswdd_t ypserv_t ypxfr_t }:process { ptrace signal_perms };
-	ps_process_pattern($1, { ypbind_t yppasswdd_t ypserv_t ypxfr_t })
+	allow $1 yppasswdd_t:process signal_perms;
+	ps_process_pattern($1, yppasswdd_t)
+
+	allow $1 ypserv_t:process signal_perms;
+	ps_process_pattern($1, ypserv_t)
+
+	allow $1 ypxfr_t:process signal_perms;
+	ps_process_pattern($1, ypxfr_t)
 
 	nis_initrc_domtrans($1)
 	nis_initrc_domtrans_ypbind($1)
 	domain_system_change_exemption($1)
-	role_transition $2 { nis_initrc_exec_t ypbind_initrc_exec_t } system_r;
+	role_transition $2 nis_initrc_exec_t system_r;
+	role_transition $2 ypbind_initrc_exec_t system_r;
 	allow $2 system_r;
 
-	files_list_tmp($1)
-	admin_pattern($1, { ypserv_tmp_t ypbind_tmp_t })
-
 	files_list_pids($1)
-	admin_pattern($1, { ypserv_var_run_t ypbind_var_run_t yppasswdd_var_run_t })
+	admin_pattern($1, ypbind_var_run_t)
+	nis_systemctl_ypbind($1)
+	admin_pattern($1, ypbind_unit_file_t)
+	allow $1 ypbind_unit_file_t:service all_service_perms;
+
+	admin_pattern($1, yppasswdd_var_run_t)
 
 	files_list_etc($1)
 	admin_pattern($1, ypserv_conf_t)
 
-	files_search_var($1)
-	admin_pattern($1, var_yp_t)
+	admin_pattern($1, ypserv_var_run_t)
+
+	admin_pattern($1, ypserv_tmp_t)
 
-	nis_run_ypbind($1, $2)
+	nis_systemctl($1)
+	admin_pattern($1, nis_unit_file_t)
+	allow $1 nis_unit_file_t:service all_service_perms;
 ')
Index: serefpolicy-contrib-20140730/nis.te
===================================================================
--- serefpolicy-contrib-20140730.orig/nis.te
+++ serefpolicy-contrib-20140730/nis.te
@@ -5,8 +5,6 @@ policy_module(nis, 1.12.0)
 # Declarations
 #
 
-attribute_role ypbind_roles;
-
 type nis_initrc_exec_t;
 init_script_file(nis_initrc_exec_t)
 
@@ -16,16 +14,18 @@ files_type(var_yp_t)
 type ypbind_t;
 type ypbind_exec_t;
 init_daemon_domain(ypbind_t, ypbind_exec_t)
-role ypbind_roles types ypbind_t;
 
 type ypbind_initrc_exec_t;
 init_script_file(ypbind_initrc_exec_t)
 
+type ypbind_var_run_t;
+files_pid_file(ypbind_var_run_t)
+
 type ypbind_tmp_t;
 files_tmp_file(ypbind_tmp_t)
 
-type ypbind_var_run_t;
-files_pid_file(ypbind_var_run_t)
+type ypbind_unit_file_t;
+systemd_unit_file(ypbind_unit_file_t)
 
 type yppasswdd_t;
 type yppasswdd_exec_t;
@@ -40,7 +40,7 @@ type ypserv_exec_t;
 init_daemon_domain(ypserv_t, ypserv_exec_t)
 
 type ypserv_conf_t;
-files_type(ypserv_conf_t)
+files_config_file(ypserv_conf_t)
 
 type ypserv_tmp_t;
 files_tmp_file(ypserv_tmp_t)
@@ -55,6 +55,9 @@ init_daemon_domain(ypxfr_t, ypxfr_exec_t
 type ypxfr_var_run_t;
 files_pid_file(ypxfr_var_run_t)
 
+type nis_unit_file_t;
+systemd_unit_file(nis_unit_file_t)
+
 ########################################
 #
 # ypbind local policy
@@ -62,6 +65,7 @@ files_pid_file(ypxfr_var_run_t)
 dontaudit ypbind_t self:capability { net_admin sys_tty_config };
 allow ypbind_t self:fifo_file rw_fifo_file_perms;
 allow ypbind_t self:process signal_perms;
+allow ypbind_t self:{ unix_dgram_socket unix_stream_socket } create_socket_perms;
 allow ypbind_t self:netlink_route_socket r_netlink_socket_perms;
 allow ypbind_t self:tcp_socket create_stream_socket_perms;
 allow ypbind_t self:udp_socket create_socket_perms;
@@ -78,7 +82,6 @@ manage_files_pattern(ypbind_t, var_yp_t,
 kernel_read_system_state(ypbind_t)
 kernel_read_kernel_sysctls(ypbind_t)
 
-corenet_all_recvfrom_unlabeled(ypbind_t)
 corenet_all_recvfrom_netlabel(ypbind_t)
 corenet_tcp_sendrecv_generic_if(ypbind_t)
 corenet_udp_sendrecv_generic_if(ypbind_t)
@@ -88,7 +91,6 @@ corenet_tcp_sendrecv_all_ports(ypbind_t)
 corenet_udp_sendrecv_all_ports(ypbind_t)
 corenet_tcp_bind_generic_node(ypbind_t)
 corenet_udp_bind_generic_node(ypbind_t)
-
 corenet_tcp_bind_generic_port(ypbind_t)
 corenet_udp_bind_generic_port(ypbind_t)
 corenet_tcp_bind_reserved_port(ypbind_t)
@@ -96,11 +98,10 @@ corenet_udp_bind_reserved_port(ypbind_t)
 corenet_tcp_bind_all_rpc_ports(ypbind_t)
 corenet_udp_bind_all_rpc_ports(ypbind_t)
 corenet_tcp_connect_all_ports(ypbind_t)
-corenet_sendrecv_all_client_packets(ypbind_t)
-corenet_sendrecv_generic_server_packets(ypbind_t)
-
 corenet_dontaudit_tcp_bind_all_reserved_ports(ypbind_t)
 corenet_dontaudit_udp_bind_all_reserved_ports(ypbind_t)
+corenet_sendrecv_all_client_packets(ypbind_t)
+corenet_sendrecv_generic_server_packets(ypbind_t)
 
 dev_read_sysfs(ypbind_t)
 
@@ -109,12 +110,11 @@ fs_search_auto_mountpoints(ypbind_t)
 
 domain_use_interactive_fds(ypbind_t)
 
-files_read_etc_files(ypbind_t)
 files_list_var(ypbind_t)
 
-logging_send_syslog_msg(ypbind_t)
+init_search_pid_dirs(ypbind_t)
 
-miscfiles_read_localization(ypbind_t)
+logging_send_syslog_msg(ypbind_t)
 
 sysnet_read_config(ypbind_t)
 
@@ -124,7 +124,6 @@ userdom_dontaudit_search_user_home_dirs(
 optional_policy(`
 	dbus_system_bus_client(ypbind_t)
 	dbus_connect_system_bus(ypbind_t)
-
 	init_dbus_chat_script(ypbind_t)
 
 	optional_policy(`
@@ -149,7 +148,8 @@ allow yppasswdd_t self:capability dac_ov
 dontaudit yppasswdd_t self:capability sys_tty_config;
 allow yppasswdd_t self:fifo_file rw_fifo_file_perms;
 allow yppasswdd_t self:process { getsched setfscreate signal_perms };
-allow yppasswdd_t self:unix_stream_socket { accept listen };
+allow yppasswdd_t self:unix_dgram_socket create_socket_perms;
+allow yppasswdd_t self:unix_stream_socket create_stream_socket_perms;
 allow yppasswdd_t self:netlink_route_socket r_netlink_socket_perms;
 allow yppasswdd_t self:tcp_socket create_stream_socket_perms;
 allow yppasswdd_t self:udp_socket create_socket_perms;
@@ -160,14 +160,13 @@ files_pid_filetrans(yppasswdd_t, yppassw
 manage_files_pattern(yppasswdd_t, var_yp_t, var_yp_t)
 manage_lnk_files_pattern(yppasswdd_t, var_yp_t, var_yp_t)
 
-can_exec(yppasswdd_t, yppasswdd_exec_t)
+can_exec(yppasswdd_t,yppasswdd_exec_t)
 
 kernel_list_proc(yppasswdd_t)
 kernel_read_proc_symlinks(yppasswdd_t)
 kernel_getattr_proc_files(yppasswdd_t)
 kernel_read_kernel_sysctls(yppasswdd_t)
 
-corenet_all_recvfrom_unlabeled(yppasswdd_t)
 corenet_all_recvfrom_netlabel(yppasswdd_t)
 corenet_tcp_sendrecv_generic_if(yppasswdd_t)
 corenet_udp_sendrecv_generic_if(yppasswdd_t)
@@ -177,23 +176,13 @@ corenet_tcp_sendrecv_all_ports(yppasswdd
 corenet_udp_sendrecv_all_ports(yppasswdd_t)
 corenet_tcp_bind_generic_node(yppasswdd_t)
 corenet_udp_bind_generic_node(yppasswdd_t)
-
 corenet_tcp_bind_all_rpc_ports(yppasswdd_t)
 corenet_udp_bind_all_rpc_ports(yppasswdd_t)
-corenet_sendrecv_generic_server_packets(yppasswdd_t)
-
 corenet_dontaudit_tcp_bind_all_reserved_ports(yppasswdd_t)
 corenet_dontaudit_udp_bind_all_reserved_ports(yppasswdd_t)
+corenet_sendrecv_generic_server_packets(yppasswdd_t)
 
-corecmd_exec_bin(yppasswdd_t)
-corecmd_exec_shell(yppasswdd_t)
-
-domain_use_interactive_fds(yppasswdd_t)
-
-files_read_etc_files(yppasswdd_t)
-files_read_etc_runtime_files(yppasswdd_t)
-files_relabel_etc_files(yppasswdd_t)
-
+dev_read_urand(yppasswdd_t)
 dev_read_sysfs(yppasswdd_t)
 
 fs_getattr_all_fs(yppasswdd_t)
@@ -202,12 +191,20 @@ fs_search_auto_mountpoints(yppasswdd_t)
 selinux_get_fs_mount(yppasswdd_t)
 
 auth_manage_shadow(yppasswdd_t)
+auth_manage_passwd(yppasswdd_t)
 auth_relabel_shadow(yppasswdd_t)
 auth_etc_filetrans_shadow(yppasswdd_t)
 
+corecmd_exec_bin(yppasswdd_t)
+corecmd_exec_shell(yppasswdd_t)
+
+domain_use_interactive_fds(yppasswdd_t)
+
+files_read_etc_runtime_files(yppasswdd_t)
+files_relabel_etc_files(yppasswdd_t)
+
 logging_send_syslog_msg(yppasswdd_t)
 
-miscfiles_read_localization(yppasswdd_t)
 
 sysnet_read_config(yppasswdd_t)
 
@@ -219,6 +216,14 @@ optional_policy(`
 ')
 
 optional_policy(`
+    mta_send_mail(yppasswdd_t)
+')
+
+optional_policy(`
+	nis_use_ypbind(yppasswdd_t)
+')
+
+optional_policy(`
 	seutil_sigchld_newrole(yppasswdd_t)
 ')
 
@@ -234,7 +239,8 @@ optional_policy(`
 dontaudit ypserv_t self:capability sys_tty_config;
 allow ypserv_t self:fifo_file rw_fifo_file_perms;
 allow ypserv_t self:process signal_perms;
-allow ypserv_t self:unix_stream_socket { accept listen };
+allow ypserv_t self:unix_dgram_socket create_socket_perms;
+allow ypserv_t self:unix_stream_socket create_stream_socket_perms;
 allow ypserv_t self:netlink_route_socket r_netlink_socket_perms;
 allow ypserv_t self:tcp_socket connected_stream_socket_perms;
 allow ypserv_t self:udp_socket create_socket_perms;
@@ -254,7 +260,6 @@ kernel_read_kernel_sysctls(ypserv_t)
 kernel_list_proc(ypserv_t)
 kernel_read_proc_symlinks(ypserv_t)
 
-corenet_all_recvfrom_unlabeled(ypserv_t)
 corenet_all_recvfrom_netlabel(ypserv_t)
 corenet_tcp_sendrecv_generic_if(ypserv_t)
 corenet_udp_sendrecv_generic_if(ypserv_t)
@@ -264,31 +269,27 @@ corenet_tcp_sendrecv_all_ports(ypserv_t)
 corenet_udp_sendrecv_all_ports(ypserv_t)
 corenet_tcp_bind_generic_node(ypserv_t)
 corenet_udp_bind_generic_node(ypserv_t)
-
 corenet_tcp_bind_reserved_port(ypserv_t)
 corenet_udp_bind_reserved_port(ypserv_t)
 corenet_tcp_bind_all_rpc_ports(ypserv_t)
 corenet_udp_bind_all_rpc_ports(ypserv_t)
-corenet_sendrecv_generic_server_packets(ypserv_t)
-
 corenet_dontaudit_tcp_bind_all_reserved_ports(ypserv_t)
 corenet_dontaudit_udp_bind_all_reserved_ports(ypserv_t)
+corenet_sendrecv_generic_server_packets(ypserv_t)
 
-corecmd_exec_bin(ypserv_t)
+dev_read_sysfs(ypserv_t)
 
-files_read_etc_files(ypserv_t)
-files_read_var_files(ypserv_t)
+fs_getattr_all_fs(ypserv_t)
+fs_search_auto_mountpoints(ypserv_t)
 
-dev_read_sysfs(ypserv_t)
+corecmd_exec_bin(ypserv_t)
 
 domain_use_interactive_fds(ypserv_t)
 
-fs_getattr_all_fs(ypserv_t)
-fs_search_auto_mountpoints(ypserv_t)
+files_read_var_files(ypserv_t)
 
 logging_send_syslog_msg(ypserv_t)
 
-miscfiles_read_localization(ypserv_t)
 
 nis_domtrans_ypxfr(ypserv_t)
 
@@ -310,8 +311,8 @@ optional_policy(`
 # ypxfr local policy
 #
 
-allow ypxfr_t self:unix_stream_socket { accept listen };
-allow ypxfr_t self:unix_dgram_socket { accept listen };
+allow ypxfr_t self:unix_stream_socket create_stream_socket_perms;
+allow ypxfr_t self:unix_dgram_socket create_stream_socket_perms;
 allow ypxfr_t self:tcp_socket create_stream_socket_perms;
 allow ypxfr_t self:udp_socket create_socket_perms;
 allow ypxfr_t self:netlink_route_socket r_netlink_socket_perms;
@@ -326,7 +327,6 @@ allow ypxfr_t ypserv_conf_t:file read_fi
 manage_files_pattern(ypxfr_t, ypxfr_var_run_t, ypxfr_var_run_t)
 files_pid_filetrans(ypxfr_t, ypxfr_var_run_t, file)
 
-corenet_all_recvfrom_unlabeled(ypxfr_t)
 corenet_all_recvfrom_netlabel(ypxfr_t)
 corenet_tcp_sendrecv_generic_if(ypxfr_t)
 corenet_udp_sendrecv_generic_if(ypxfr_t)
@@ -336,23 +336,19 @@ corenet_tcp_sendrecv_all_ports(ypxfr_t)
 corenet_udp_sendrecv_all_ports(ypxfr_t)
 corenet_tcp_bind_generic_node(ypxfr_t)
 corenet_udp_bind_generic_node(ypxfr_t)
-
 corenet_tcp_bind_reserved_port(ypxfr_t)
 corenet_udp_bind_reserved_port(ypxfr_t)
 corenet_tcp_bind_all_rpc_ports(ypxfr_t)
 corenet_udp_bind_all_rpc_ports(ypxfr_t)
+corenet_dontaudit_tcp_bind_all_reserved_ports(ypxfr_t)
+corenet_dontaudit_udp_bind_all_reserved_ports(ypxfr_t)
 corenet_tcp_connect_all_ports(ypxfr_t)
 corenet_sendrecv_generic_server_packets(ypxfr_t)
 corenet_sendrecv_all_client_packets(ypxfr_t)
 
-corenet_dontaudit_tcp_bind_all_reserved_ports(ypxfr_t)
-corenet_dontaudit_udp_bind_all_reserved_ports(ypxfr_t)
-
-files_read_etc_files(ypxfr_t)
 files_search_usr(ypxfr_t)
 
 logging_send_syslog_msg(ypxfr_t)
 
-miscfiles_read_localization(ypxfr_t)
 
 sysnet_read_config(ypxfr_t)
Index: serefpolicy-contrib-20140730/nova.fc
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/nova.fc
@@ -0,0 +1,33 @@
+
+/usr/bin/nova-ajax-console-proxy	--	gen_context(system_u:object_r:nova_ajax_exec_t,s0)
+/usr/bin/nova-console.*		--	gen_context(system_u:object_r:nova_console_exec_t,s0)
+/usr/bin/nova-direct-api	--  gen_context(system_u:object_r:nova_direct_exec_t,s0)
+/usr/bin/nova-api			--  gen_context(system_u:object_r:nova_api_exec_t,s0)
+/usr/bin/nova-cert           --  gen_context(system_u:object_r:nova_cert_exec_t,s0)
+/usr/bin/nova-conductor     --  gen_context(system_u:object_r:nova_conductor_exec_t,s0)
+/usr//bin/nova-api-metadata	--	gen_context(system_u:object_r:nova_api_exec_t,s0)
+/usr/bin/nova-network       --  gen_context(system_u:object_r:nova_network_exec_t,s0)
+/usr/bin/nova-objectstore       --  gen_context(system_u:object_r:nova_objectstore_exec_t,s0)
+/usr/bin/nova-scheduler     --  gen_context(system_u:object_r:nova_scheduler_exec_t,s0)
+/usr/bin/nova-vncproxy      --  gen_context(system_u:object_r:nova_vncproxy_exec_t,s0)
+/usr/bin/nova-volume        --  gen_context(system_u:object_r:nova_volume_exec_t,s0)
+/usr/bin/nova-xvpvncproxy	--	gen_context(system_u:object_r:nova_vncproxy_exec_t,s0)
+
+/usr/lib/systemd/system/openstack-nova-ajax-console-proxy.*	--	gen_context(system_u:object_r:nova_ajax_unit_file_t,s0)
+/usr/lib/systemd/system/openstack-nova-api.*		--	gen_context(system_u:object_r:nova_api_unit_file_t,s0)
+/usr/lib/systemd/system/openstack-nova-cert.*	--	gen_context(system_u:object_r:nova_cert_unit_file_t,s0)
+/usr/lib/systemd/system/openstack-nova-console.*    --  gen_context(system_u:object_r:nova_console_unit_file_t,s0)
+/usr/lib/systemd/system/openstack-nova-direct-api.*	--	gen_context(system_u:object_r:nova_direct_unit_file_t,s0)
+/usr/lib/systemd/system/openstack-nova-metadata-api.service.*	--	gen_context(system_u:object_r:nova_api_unit_file_t,s0)
+/usr/lib/systemd/system/openstack-nova-network.*	--	gen_context(system_u:object_r:nova_network_unit_file_t,s0)
+/usr/lib/systemd/system/openstack-nova-objectstore.*	--	gen_context(system_u:object_r:nova_objectstore_unit_file_t,s0)
+/usr/lib/systemd/system/openstack-nova-scheduler.*	--	gen_context(system_u:object_r:nova_scheduler_unit_file_t,s0)
+/usr/lib/systemd/system/openstack-nova-vncproxy.*	--	gen_context(system_u:object_r:nova_vncproxy_unit_file_t,s0)
+/usr/lib/systemd/system/openstack-nova-xvpvncproxy.*   --  gen_context(system_u:object_r:nova_vncproxy_unit_file_t,s0)
+/usr/lib/systemd/system/openstack-nova-volume.*		--	gen_context(system_u:object_r:nova_volume_unit_file_t,s0)
+
+/var/lib/nova(/.*)?     gen_context(system_u:object_r:nova_var_lib_t,s0)
+
+/var/log/nova(/.*)?     gen_context(system_u:object_r:nova_log_t,s0)
+
+/var/run/nova(/.*)?     gen_context(system_u:object_r:nova_var_run_t,s0)
Index: serefpolicy-contrib-20140730/nova.if
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/nova.if
@@ -0,0 +1,57 @@
+## <summary>openstack-nova</summary>
+
+######################################
+## <summary>
+##  Manage nova lib files.
+## </summary>
+## <param name="domain">
+##  <summary>
+##  Domain allowed access.
+##  </summary>
+## </param>
+#
+interface(`nova_manage_lib_files',`
+    gen_require(`
+                type nova_var_lib_t;
+                                ')
+
+    files_search_var_lib($1)
+    manage_files_pattern($1, nova_var_lib_t, nova_var_lib_t)
+')
+
+#######################################
+## <summary>
+##  Creates types and rules for a basic
+##  openstack-nova systemd daemon domain.
+## </summary>
+## <param name="prefix">
+##  <summary>
+##  Prefix for the domain.
+##  </summary>
+## </param>
+#
+template(`nova_domain_template',`
+	gen_require(`
+		attribute nova_domain;
+	')
+
+	type nova_$1_t, nova_domain;
+	type nova_$1_exec_t;
+	init_daemon_domain(nova_$1_t, nova_$1_exec_t)
+
+	type nova_$1_unit_file_t;
+	systemd_unit_file(nova_$1_unit_file_t)
+
+	type nova_$1_tmp_t;
+	files_tmp_file(nova_$1_tmp_t)
+
+	manage_dirs_pattern(nova_$1_t, nova_$1_tmp_t, nova_$1_tmp_t)
+	manage_files_pattern(nova_$1_t, nova_$1_tmp_t, nova_$1_tmp_t)
+	files_tmp_filetrans(nova_$1_t, nova_$1_tmp_t, { file dir })
+	can_exec(nova_$1_t, nova_$1_tmp_t)
+
+	kernel_read_system_state(nova_$1_t)
+
+    logging_send_syslog_msg(nova_$1_t)
+
+')
Index: serefpolicy-contrib-20140730/nova.te
===================================================================
--- /dev/null
+++ serefpolicy-contrib-20140730/nova.te
@@ -0,0 +1,328 @@
+policy_module(nova, 1.0.0)
+
+########################################
+#
+# Declarations
+#
+
+#
+# nova-stack daemons contain security issue with using sudo in the code
+# we make this policy as unconfined until this issue is fixed
+#
+
+attribute nova_domain;
+attribute nova_sudo_domain;
+
+nova_domain_template(ajax)
+nova_domain_template(api)
+nova_domain_template(cert)
+nova_domain_template(conductor)
+nova_domain_template(compute)
+nova_domain_template(console)
+nova_domain_template(direct)
+nova_domain_template(network)
+nova_domain_template(objectstore)
+nova_domain_template(scheduler)
+nova_domain_template(vncproxy)
+nova_domain_template(volume)
+
+typeattribute nova_api_t nova_sudo_domain;
+typeattribute nova_cert_t nova_sudo_domain;
+typeattribute nova_console_t nova_sudo_domain;
+typeattribute nova_network_t nova_sudo_domain;
+typeattribute nova_volume_t nova_sudo_domain;
+
+type nova_log_t;
+logging_log_file(nova_log_t)
+
+type nova_var_lib_t;
+files_type(nova_var_lib_t)
+
+type nova_var_run_t;
+files_pid_file(nova_var_run_t)
+
+
+######################################
+#
+# nova general domain local policy
+#
+
+allow nova_domain self:process signal_perms;
+allow nova_domain self:fifo_file rw_fifo_file_perms;
+allow nova_domain self:tcp_socket create_stream_socket_perms;
+allow nova_domain self:unix_stream_socket create_stream_socket_perms;
+
+manage_dirs_pattern(nova_domain, nova_log_t, nova_log_t)
+manage_files_pattern(nova_domain, nova_log_t, nova_log_t)
+
+manage_dirs_pattern(nova_domain, nova_var_lib_t, nova_var_lib_t)
+manage_files_pattern(nova_domain, nova_var_lib_t, nova_var_lib_t)
+
+manage_dirs_pattern(nova_domain, nova_var_run_t, nova_var_run_t)
+manage_files_pattern(nova_domain, nova_var_run_t, nova_var_run_t)
+
+corenet_tcp_connect_amqp_port(nova_domain)
+corenet_tcp_connect_mysqld_port(nova_domain)
+
+kernel_read_network_state(nova_domain)
+
+corecmd_exec_bin(nova_domain)
+corecmd_exec_shell(nova_domain)
+corenet_tcp_connect_mysqld_port(nova_domain)
+
+auth_read_passwd(nova_domain)
+
+dev_read_sysfs(nova_domain)
+dev_read_urand(nova_domain)
+
+fs_getattr_xattr_fs(nova_domain)
+
+init_read_utmp(nova_domain)
+
+libs_exec_ldconfig(nova_domain)
+
+optional_policy(`
+    mysql_stream_connect(nova_domain)
+    mysql_read_db_lnk_files(nova_domain)
+')
+
+optional_policy(`
+	sysnet_read_config(nova_domain)
+	sysnet_exec_ifconfig(nova_domain)
+')
+
+######################################
+#
+# nova ajax local policy
+#
+
+#optional_policy(`
+#	unconfined_domain(nova_ajax_t)
+#')
+
+#######################################
+#
+# nova api local policy
+#
+
+allow nova_api_t self:process setfscreate;
+
+allow nova_api_t self:key write;
+
+allow nova_api_t self:netlink_route_socket r_netlink_socket_perms;
+
+allow nova_api_t self:udp_socket create_socket_perms;
+
+kernel_read_kernel_sysctls(nova_api_t)
+
+corenet_tcp_bind_generic_node(nova_api_t)
+corenet_udp_bind_generic_node(nova_api_t)
+# should be add to booleans
+corenet_tcp_connect_all_ports(nova_api_t)
+corenet_tcp_bind_all_unreserved_ports(nova_api_t)
+
+auth_read_passwd(nova_api_t)
+
+logging_send_syslog_msg(nova_api_t)
+
+miscfiles_read_certs(nova_api_t)
+
+optional_policy(`
+	iptables_domtrans(nova_api_t)
+')
+
+optional_policy(`
+	ssh_exec_keygen(nova_api_t)
+')
+
+optional_policy(`
+    gnome_dontaudit_search_config(nova_api_t)
+')
+
+#optional_policy(`
+#	unconfined_domain(nova_api_t)
+#')
+
+######################################
+#
+# nova cert local policy
+#
+
+allow nova_cert_t self:process setfscreate;
+
+allow nova_cert_t self:udp_socket create_socket_perms;
+
+auth_use_nsswitch(nova_cert_t)
+
+miscfiles_read_certs(nova_cert_t)
+
+optional_policy(`
+	postgresql_stream_connect(nova_cert_t)
+')
+
+#######################################
+#
+# nova conductor local policy
+#
+
+optional_policy(`
+    unconfined_domain(nova_conductor_t)
+')
+
+#######################################
+#
+# nova compute local policy
+#
+
+# needs to be re-write since now runs as virtd_t
+
+allow nova_compute_t self:udp_socket create_socket_perms;
+
+kernel_read_network_state(nova_compute_t)
+
+dev_read_rand(nova_compute_t)
+
+optional_policy(`
+	virt_getattr_exec(nova_compute_t)
+	virt_stream_connect(nova_compute_t)
+')
+
+######################################
+#
+# nova console local policy
+#
+
+allow nova_console_t self:udp_socket create_socket_perms;
+
+auth_use_nsswitch(nova_console_t)
+
+#######################################
+#
+# nova direct local policy
+#
+
+#optional_policy(`
+#	unconfined_domain(nova_direct_t)
+#')
+
+#######################################
+#
+# nova network local policy
+#
+
+allow nova_network_t self:capability { dac_override net_admin net_bind_service };
+allow nova_network_t self:process { getcap setcap };
+
+allow nova_network_t self:netlink_route_socket r_netlink_socket_perms;
+allow nova_network_t self:udp_socket create_socket_perms;
+
+kernel_read_network_state(nova_network_t)
+kernel_read_kernel_sysctls(nova_network_t)
+
+# should be added to boolean or fixed in the code
+# dnsmasq domtrans does not work since then dnsmasq_t wants
+# to do some stuff with nova_lib, nova_tmp
+# nova-dhcpbridge runs in dnsmasq domain
+corenet_all_recvfrom_netlabel(nova_network_t)
+corenet_tcp_sendrecv_generic_if(nova_network_t)
+corenet_udp_sendrecv_generic_if(nova_network_t)
+corenet_raw_sendrecv_generic_if(nova_network_t)
+corenet_tcp_sendrecv_generic_node(nova_network_t)
+corenet_udp_sendrecv_generic_node(nova_network_t)
+corenet_raw_sendrecv_generic_node(nova_network_t)
+corenet_tcp_sendrecv_all_ports(nova_network_t)
+corenet_udp_sendrecv_all_ports(nova_network_t)
+corenet_tcp_bind_generic_node(nova_network_t)
+corenet_udp_bind_generic_node(nova_network_t)
+corenet_tcp_bind_dns_port(nova_network_t)
+corenet_udp_bind_all_ports(nova_network_t)
+corenet_sendrecv_dns_server_packets(nova_network_t)
+corenet_sendrecv_dhcpd_server_packets(nova_network_t)
+
+libs_exec_ldconfig(nova_network_t)
+
+logging_send_syslog_msg(nova_network_t)
+
+optional_policy(`
+	brctl_domtrans(nova_network_t)
+')
+
+optional_policy(`
+	dnsmasq_exec(nova_network_t)
+#	dnsmasq_domtrans(nova_network_t)
+')
+
+optional_policy(`
+	iptables_domtrans(nova_network_t)
+')
+
+optional_policy(`
+	sysnet_domtrans_ifconfig(nova_network_t)
+')
+
+#optional_policy(`
+#	unconfined_domain(nova_network_t)
+#')
+
+#######################################
+#
+# nova object store local policy
+#
+
+allow nova_objectstore_t self:udp_socket create_socket_perms;
+
+corenet_tcp_bind_generic_node(nova_objectstore_t)
+corenet_udp_bind_generic_node(nova_objectstore_t)
+
+optional_policy(`
+    unconfined_domain(nova_objectstore_t)
+')
+
+#######################################
+#
+# nova scheduler local policy
+#
+
+allow nova_scheduler_t self:netlink_route_socket r_netlink_socket_perms;
+allow nova_scheduler_t self:udp_socket create_socket_perms;
+
+auth_read_passwd(nova_scheduler_t)
+
+init_read_utmp(nova_scheduler_t)
+
+#######################################
+#
+# nova vncproxy local policy
+#
+
+#######################################
+#
+# nova volume local policy
+#
+
+allow nova_volume_t self:netlink_route_socket r_netlink_socket_perms;
+
+allow nova_volume_t self:udp_socket create_socket_perms;
+
+kernel_read_kernel_sysctls(nova_volume_t)
+
+logging_send_syslog_msg(nova_volume_t)
+
+optional_policy(`
+	lvm_domtrans(nova_volume_t)
+')
+
+#######################################
+#
+# nova sudo domain local policy
+#
+
+ifdef(`hide_broken_symptoms',`
+	optional_policy(`
+		sudo_exec(nova_sudo_domain)
+        allow nova_sudo_domain self:capability { setuid sys_resource setgid audit_write };
+		allow nova_sudo_domain self:process { setsched setrlimit };
+		logging_send_audit_msgs(nova_sudo_domain)
+	')
+')
+
Index: serefpolicy-contrib-20140730/nscd.fc
===================================================================
--- serefpolicy-contrib-20140730.orig/nscd.fc
+++ serefpolicy-contrib-20140730/nscd.fc
@@ -1,13 +1,15 @@
 /etc/rc\.d/init\.d/nscd	--	gen_context(system_u:object_r:nscd_initrc_exec_t,s0)
 
-/usr/sbin/nscd	--	gen_context(system_u:object_r:nscd_exec_t,s0)
+/usr/sbin/nscd		--	gen_context(system_u:object_r:nscd_exec_t,s0)
 
-/var/cache/nscd(/.*)?	gen_context(system_u:object_r:nscd_var_run_t,s0)
-
-/var/db/nscd(/.*)?	gen_context(system_u:object_r:nscd_var_run_t,s0)
+/var/db/nscd(/.*)?		gen_context(system_u:object_r:nscd_var_run_t,s0)
+/var/cache/nscd(/.*)?		gen_context(system_u:object_r:nscd_var_run_t,s0)
 
 /var/log/nscd\.log.*	--	gen_context(system_u:object_r:nscd_log_t,s0)
 
-/var/run/nscd(/.*)?	gen_context(system_u:object_r:nscd_var_run_t,s0)
 /var/run/nscd\.pid	--	gen_context(system_u:object_r:nscd_var_run_t,s0)
 /var/run/\.nscd_socket	-s	gen_context(system_u:object_r:nscd_var_run_t,s0)
+
+/var/run/nscd(/.*)?		gen_context(system_u:object_r:nscd_var_run_t,s0)
+
+/usr/lib/systemd/system/nscd\.service -- gen_context(system_u:object_r:nscd_unit_file_t,s0)
